Subject: Re: [bug#40950] [PATCH] mcron, create /var/cron/tabs on activation

From: sirmacik <[email-masked]>
Date: Mon, 25 May 2020 20:08:50 +0200

Ludovic Courtès <[email-masked]> writes:

> Hi Marcin,
>
> Marcin Karpezo <[email-masked]> skribis:
>
>> 2 maj 2020 00:06:16 Ludovic Courtès <[email-masked]>:
>>
>>> Hi Marcin,
>>> Marcin Karpezo <[email-masked]> skribis:
>>>
>>>
>>> > With big rekado help I'm sending you a patch with at least
>>> > partially fixes the issue of crontab -e reporting missing
>>> > /var/cron/tabs directory.
>>> >
>>> Unless I’m mistaken, creating /var/cron/tabs will silence “crontab
>>> -e”, but those entries will still be ignored because mcron’s crond
>>> is not running (IIRC the cron functionality of mcron is separate and
>>> requires you to run crond, which we don’t do.)
>>> One option would be to write a different service altogether running
>>> that daemon and creates /var/cron/tabs like you did.
>>> Another option would be to remote the ‘crontab’ program from our
>>> ‘mcron’ package to at least avoid disappointments.
>>> Thoughts?
>>
>> Why won't start supporting and running mcron's crond daemon? That way
>> guix will finally have normal fully functional cron which will ease
>> administration not only on personal machines but also on server
>> side. It's nice to have everything defined in one config file but it
>> isn't as handy for multiuser setup.
>
> Yeah I agree.  (I personally run a user shepherd, itself starting a user
> mcron, but I admit that’s a config not everyone may be willing to
> replicate.)
>
>> I think instead of avoiding disappointment it would be better to
>> positively surprise the users. I know that guix thrives in what sets
>> it apart from other distros, but it's better to keep things standard
>> whenever its possible and follow the rule of least
>> surprise. Especially if it won't be damaging for the goals of the
>> project.
>
> Agreed!
>
> That brings us to my first proposal above: writing a crond service that
> runs mcron’s crond.  Would you like to give it a try?
>
> (There’s also scron available.  I think someone had proposed a service
> for it, but I can’t find it.)

Dear Ludo’,

I haven't forgot about this issue. Writing simple service isn't a
problem, but I've found out that despite running cron daemon, crontab
doesn't notice it. I've reported that behaviour on mcron mailing
list[1].

Second issue that I haven't figured out yet is creating crontab file for
each user of the system upon cron service activation. It needs
/var/cron/tabs to be owned by root: and crontab for each user to be
owned by him, ideally by (for example) user1:user1. 

[1] https://lists.gnu.org/archive/html/bug-mcron/2020-05/msg00012.html

--
Cheers,
sirmacik
PGP: 0xE0DC81D523891771